;====== Displej ======
;procedure Disp.Clear smaze obrazovku
disp_clear
        ld      a,1
        call    disp_inst
        xor     a
        ld      (disp_x),a
        ld      (disp_y),a
        call    disp_setpos
        ret

disp_defchar
        ld      a,#40
        call    disp_inst
        ld      b,64
disp_defchar1
        ld      a,(hl)
        inc     hl
        call    disp_data
        djnz    disp_defchar1
        ld      a,#80
        call    disp_inst
        ret

; procedure WriteBIN(A:data)
disp_wrbin
        push    bc
        ld      b,8
disp_wrbin2
        rrca
        push    af
        ld      a,'0'
        jr      nc,disp_wrbin1
        inc     a
disp_wrbin1
        call    disp_wrchar
        pop     af
        djnz    disp_wrbin2
        pop     bc
        ret

; procedure WriteBCD(A:data)
disp_wrbcd
        push    af
        rlca
        rlca
        rlca
        rlca
        and     #0f
        add     a,48
        call    disp_wrchar
        pop     af
        and     #0f
        add     a,48
        call    disp_wrchar
        ret
; procedure Write(HL:retezec ukonceny nulou)
disp_write
        ld      a,(hl)
        or      a
        ret     z
        call    disp_wrchar
        inc     hl
        jr      disp_write

; procedure WriteChar(C:znak)
disp_wrchar
        cp      10              ;dalsi radek
        jr      z,disp_wrchar2
        cp      8            ;backspace
        jr      nz,disp_wrchar6
        ld      a,(disp_x)
        dec     a
        jr      c,disp_wrchar7
        ld      (disp_x),a
        jr      disp_wrchar9
disp_wrchar7
        ld      a,19
        ld      (disp_x),a
        ld      a,(disp_y)
        dec     a
        jr      nc,disp_wrchar8
        ld      a,3
disp_wrchar8
        ld      (disp_y),a
disp_wrchar9
        call    disp_setpos
        ld      a,' '
        call    disp_data
        call    disp_setpos
        jr      disp_wrchar4
disp_wrchar6                    ;zobrazeni bezneho znaku
        call    disp_data

disp_wrchar4                    ;prepocet pozice
        ld      a,(disp_x)
        inc     a
        cp      20
        jr      nc,disp_wrchar2
        ld      (disp_x),a
        call    disp_setpos
        ret
disp_wrchar2
        xor      a
        ld      (disp_x),a
        ld      a,(disp_y)
        inc     a
        cp      4
        jr      c,disp_wrchar3
        xor     a
disp_wrchar3
        ld      (disp_y),a
        call    disp_setpos
        ret

; procedure Disp.SetPos;
disp_setpos
        push    bc
        ld      bc,0
        ld      a,(disp_y)
        rrca
        jr      nc,disp_setpos2
        ld      b,64
disp_setpos2
        rrca
        jr      nc,disp_setpos3
        ld      c,20
disp_setpos3
        ld      a,(disp_x)
        add     b
        add     c
        or      #80
        out     (#40),a
        pop     bc
        ret

; procedure Disp.Busy
disp_busy
        in      a,(#42)
        out     (#ff),a
        ret

; procedure Disp.Reset
disp_reset                      ;Resetuje displej
        ld      bc,15           ;15 ms
        call    delay
        ld      a,#30
        out     (#40),a
        ld      bc,5            ;5 ms
        call    delay
        ld      a,#30
        out     (#40),a
        ld      bc,1            ;1 ms
        call    delay
        ld      a,#30
        out     (#40),a
        ld      a,#3c           ;8bit sbernice,4 radky
        call    disp_inst
        ld      a,#0e           ;displej on,kurzor on
        call    disp_inst
        ld      a,#06           ;psani doprava,posun disp off
        call    disp_inst
        ld      a,#01           ;smazani displej
        call    disp_inst
        ld      a,#02           ;na zacatek
        call    disp_inst
        ld      hl,disp_chars
        call    disp_defchar
        ld      a,0
        ld      (disp_x),a
        ld      (disp_y),a
        call    disp_setpos
        ret

; procedure Disp.Inst(A:kod instrukce)
disp_inst
        push    bc
        ld      bc,2
        call    delay
        pop     bc
        out     (#40),a
        ret

; procedure Disp.Data(A:znak)
disp_data
        push    bc
        ld      bc,2
        call    delay
        pop     bc
        out     (#41),a
        ret

disp_x  equ     #8000   ;X-ova pozice
disp_y  equ     #8001   ;Y-ova pozice
disp_chars
        db      0,0,0,0,0,0,0,0
        db      #e,#e,4,#1f,4,4,#a,#11  ;panacek
        db      0,0,0,0,0,0,0,0
        db      0,0,0,0,0,0,0,0
        db      0,0,0,0,0,0,0,0
        db      0,0,0,0,0,0,0,0
        db      0,0,0,0,0,0,0,0
        db      0,0,0,0,0,0,0,0
